package com.example.switchyard.callee;

import org.jboss.resteasy.client.ClientRequest;
import org.jboss.resteasy.client.ClientResponse;
import org.switchyard.component.bean.Service;

@Service(StartService.class)
public class StartServiceBean implements StartService {

	private static final String CONNECT_URL = "http://localhost:8079/caller/service/start";

	@Override
	public void start() {

		System.out.println("Callee got request to set demo in motion - requesting start of caller at: " + CONNECT_URL);

		try {
			ClientRequest restRequest = new ClientRequest(CONNECT_URL);
			ClientResponse<?> response = restRequest.get();

			System.out.println("Caller returned status code on start request: " + response.getStatus());

		} catch (Exception e) {
			System.out.println("Error trying to connect to caller");
			e.printStackTrace();
		}
	}


}
