package com.example.switchyard.caller;

import java.util.concurrent.atomic.AtomicLong;

import javax.inject.Inject;

import org.switchyard.component.bean.Reference;
import org.switchyard.component.bean.Service;

import com.example.switchyard.module.CallService;

@Service(RunnerService.class)
public class RunnerServiceBean implements Runnable, RunnerService {

	private static final AtomicLong serialCounter = new AtomicLong();

	@Inject
	@Reference
	private CallService callService;

	private long instanceSerial;


	public RunnerServiceBean() {
		instanceSerial = serialCounter.incrementAndGet();
	}

	@Override
	public void run() {

		try {
			System.out.println("Caller is about to send data to: " + callService);
			callService.call("Hello callee from caller #" + instanceSerial + "!");
			System.out.println("Caller finished sending data");
		} catch (Exception e) {
			System.out.println("Caller experienced an error sending data");
			e.printStackTrace();
		}
	}

}
