package com.example.switchyard.caller;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.inject.Inject;
import javax.inject.Singleton;

import org.switchyard.component.bean.Reference;
import org.switchyard.component.bean.Service;

import com.example.switchyard.module.CallService;

@Service(StartService.class)
public class StartServiceBean implements StartService {

	// TODO: Do not actually want a single runner for the start service, but this is what works now.
	@Inject
	@Reference
	private RunnerService runner;

	@Override
	public void start() {

		System.out.println("Caller receiving request to start");

		try {

			runner.run();

			// TODO: Need to do something like this where the runner is instantiated for each call,
			// rather than using a single runner.
			// RunnerServiceBean runner = new RunnerServiceBean();
			// ExecutorService executorService = Executors.newSingleThreadExecutor();
			// executorService.execute(runner);

		} catch (Exception e) {
			System.out.println("Caller experienced error trying to start");
			e.printStackTrace();

		}
	}
}
